//constructors

class pair1{
	int first, second;
};

class pair2{
	int first, second;

	pair2(){
		first=1;
		second=2;
	}

	pair2(pair2& p){
		first=p.second;
		second=p.first;
	}

	pair2(int x, int y) : first(x){
		second=y;
	}
};

class pair3{
	int& first, &second;

	pair3(pair1& p) : first(p.first), second(p.second){}
};

nil printl(string s, pair1 p){
	using::write(s+"="+using::debug(p)+"\n");
}

nil printl(string s, pair2 p){
	using::write(s+"="+using::debug(p)+"\n");
}

nil printl(string s, pair3 p){
	using::write(s+"="+using::debug(p)+"\n");
}

process main(){
	pair1 p1;
	printl("p1",p1);
	p1.first=1;
	pair1 p2(p1);
	printl("p2",p2);

	pair2 p3;
	printl("p3",p3);
	pair2 p4(p3);
	printl("p4",p4);
	pair2 p5(10,5);
	printl("p5",p5);

	/* pair3 p7; invalid */
	pair3 p6(p2);
	printl("p6",p6);
	pair3 p8(p6);
	printl("p8",p8);
}
